package com.idtechproducts.device.sdkdemo;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import com.dbconnection.dblibrarybeta.ProfileManager;
import com.dbconnection.dblibrarybeta.RESTResponse;
import com.idtechproducts.device.Common;
import com.idtechproducts.device.ErrorCode;
import com.idtechproducts.device.ErrorCodeInfo;
import com.idtechproducts.device.IDTEMVData;
import com.idtechproducts.device.IDTMSRData;
import com.idtechproducts.device.IDT_NEO2;
import com.idtechproducts.device.IDT_SecureMag;
import com.idtechproducts.device.OnReceiverListener;
import com.idtechproducts.device.ReaderInfo.DEVICE_TYPE;
import com.idtechproducts.device.audiojack.tools.FirmwareUpdateTool;
import com.idtechproducts.device.ResDataStruct;
import com.idtechproducts.device.StructConfigParameters;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class UnifiedSDK_Demo  extends ActionBarActivity{

	private SdkDemoFragment mainView = null;
	public StructConfigParameters debugProfile;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_demo);

//		if (savedInstanceState == null) {
			mainView = new SdkDemoFragment();
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, mainView).commit();
//		}
		
    	getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
	}
	
	@Override
	public void onBackPressed() {
	}
	
	
	// Inflate the menu items to the action bar
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()) {
		
		case R.id.action_switch_reader_type:
			mainView.openReaderSelectDialog();
			break;
		
		case R.id.action_start_rki:
			mainView.startRemoteKeyInjection();
			break;
		case R.id.action_enable_log:
			boolean toEnable = !item.isChecked();
			item.setChecked(toEnable);
			mainView.enableLogFeature(toEnable);
			break;
		case R.id.action_delete_log:
			mainView.deleteLogs();
			break;
		case R.id.action_exit_app:
			mainView.releaseSDK();
			finish();
			break;
		}
		return super.onOptionsItemSelected(item);
	}
	
	public class SdkDemoFragment extends Fragment implements OnReceiverListener, RESTResponse
	{
		private IDT_SecureMag device;
		private boolean calcLRC = true;

		private TextView status;
		private TextView infoText;
		private TextView dataText;
		private View rootView;
		private LayoutInflater layoutInflater;
		private ViewGroup viewGroup;
		
		private String info = "";
		private String detail = "";
		private Handler handler = new Handler();

		private StructConfigParameters config = null;
		private Button commandBtn;
		private boolean switchToKB = true;
		private boolean switchInterface = false;
		
		private String[] commands = {
				"Get Version",  		// 0 
				"Get Serial Number", 	// 1
				"Send raw command",		// 2
				"Get Setting", 			// 3
				"Enable TDES", 			// 4
				"Enable AES", 			// 5
				"Get Next KSN",			// 6
				"Default Settings",		// 7
				"Enable Error Notif.",	// 8 
				"Disable Error Notif.",	// 9 
				"Enable Exp. Date",		// 10
				"Disable Exp. Date",	// 11
				"Set Enhanced Encryption mode",		// 12
				"Set Original Encryption mode",		// 13
				"Switch To Keyboard mode"		// 14
		};
		
		private ProfileManager profileManager;
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			layoutInflater = inflater;
			viewGroup = container;
			rootView = inflater.inflate(R.layout.fragment_main, container, false);
			
			status = (TextView)rootView.findViewById(R.id.status_text);
			status.setText("Disconnected");
			
			infoText = (TextView)rootView.findViewById(R.id.text_area_top);
			dataText = (TextView)rootView.findViewById(R.id.text_area_bottom);
			dataText.setVerticalScrollBarEnabled(true);
			
			commandBtn = (Button)rootView.findViewById(R.id.btn_command);
			commandBtn.setOnClickListener(new CommandButtonListener());
			profileManager = new ProfileManager(this);
			
			return rootView;
		}
		
		@Override
		public void onActivityCreated(Bundle savedInstanceState) {
			
			if (device != null)
				device.unregisterListen();
//			initializeReader();
			openReaderSelectDialog();
		    
			super.onActivityCreated(savedInstanceState);
		}
		
		@Override
		public void onDestroy() {
			if (device != null)
				device.unregisterListen();
			super.onDestroy();
		}
		
		public void initializeReader()
		{
			if (device != null){
				releaseSDK();
			}
			device = new IDT_SecureMag(this, getActivity());
			profileManager.doGet();
			Toast.makeText(getActivity(), "get started", Toast.LENGTH_LONG).show();
	        device.log_setVerboseLoggingEnable(true);
	        if (switchInterface)
	        	switchInterface = false;
	        else
	        	displaySdkInfo();
		}

//		public void initializeReader()
//		{
//			if (device != null){
//				releaseSDK();
//			}
//			device = new IDT_SecureMag(this, getActivity());
//			profileManager.doGet();
//			Toast.makeText(getActivity(), "get started", Toast.LENGTH_LONG).show();
//	        device.log_setVerboseLoggingEnable(true);        
//        	displaySdkInfo();
//        	if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_SECUREMAG))
//			{
////				Toast.makeText(getActivity(), "SecureMag is selected", Toast.LENGTH_SHORT).show();
//			}
//			else
//				Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
//	    	device.registerListen();
//		}

	    void startRemoteKeyInjection()
	    {
	    	int ret = device.device_startRKI();
			if (ret != ErrorCode.SUCCESS) {
				info = "SDK could not start RKI: "+ErrorCodeInfo.getErrorCodeDescription(ret);
				detail = "";
			}
			else {
				info = "Remote key injection process started...\nPlease wait...";
				detail = "";
			}
			handler.post(doUpdateStatus);

	    }
	    
//	    void openReaderSelectDialog() {
//	    	initializeReader();
//	    	if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_SECUREMAG))
//			{
//				Toast.makeText(getActivity(), "SecureMag is selected", Toast.LENGTH_SHORT).show();
//			}
//			else 
//				Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
//	    	device.registerListen();
//	    }
	    
	    void openReaderSelectDialog() {
	    	initializeReader();
	    	AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
	    	builder.setTitle("Select a device:");
	    	builder.setCancelable(false);
	    	builder.setItems(R.array.reader_type, new DialogInterface.OnClickListener() {
				
				public void onClick(DialogInterface dialog, int which) {
					switch(which) {

					case 0:
						if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_SECUREMAG))
						{
							Toast.makeText(getActivity(), "SecureMag HID-USB is selected", Toast.LENGTH_SHORT).show();
							commands[14] = "Switch To Keyboard mode";
						}
						else 
							Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
						break;
					case 1:
						if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_SECUREMAG_KB))
						{
							Toast.makeText(getActivity(), "SecureMag KB is selected", Toast.LENGTH_SHORT).show();
							commands[14] = "Switch To HID-USB mode";
						}
						else 
							Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
						break;
					}
//					device.setIDT_Device(fwTool);
					device.registerListen();
				}
			});
	    	builder.create().show();
	    }
	    
	    void openReader() {
	    	switchInterface = true;
	    	initializeReader();
				
	    	if (switchToKB)
	    	{
	    		if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_SECUREMAG_KB))
				{
					Toast.makeText(getActivity(), "SecureMag KB is selected", Toast.LENGTH_SHORT).show();
					commands[14] = "Switch To HID-USB mode";
				}
				else 
					Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
	    	}
	    	else
	    	{
	    		if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_SECUREMAG))
				{
					Toast.makeText(getActivity(), "SecureMag HID-USB is selected", Toast.LENGTH_SHORT).show();
					commands[14] = "Switch To Keyboard mode";
				}
				else 
					Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
	    	}
			device.registerListen();
	    }
		
		public void lcdDisplay(int mode, String[] lines, int timeout) {

		}
		
		public void lcdDisplay(int mode, String[] lines, int timeout, byte[] languageCode, byte messageId) {

		}
		
		public void releaseSDK() {
			if (device != null) {
				device.unregisterListen();
				device.release();
			}			
		}

		public void enableLogFeature (boolean enable) {
			if (device != null) {
				device.log_setSaveLogEnable(enable);
			}
			
			if (enable)
				Toast.makeText(getActivity(), "Log feature enabled", Toast.LENGTH_SHORT).show();
			else 
				Toast.makeText(getActivity(), "Log feature disabled", Toast.LENGTH_SHORT).show();
		}
		
		public void deleteLogs()
		{
			if (device != null) {
				int fileDeleted = device.log_deleteLogs();
				Toast.makeText(getActivity(), "Total of "+fileDeleted+" files are deleted.", Toast.LENGTH_SHORT).show();
			}
		}
		
		public void displaySdkInfo() {
			info = 	"Manufacturer: " + android.os.Build.MANUFACTURER + "\n" + 
					"Model: " + android.os.Build.MODEL + "\n" + 
					"OS Version: " + android.os.Build.VERSION.RELEASE + " \n" +
					"SDK Version: \n" + device.config_getSDKVersion() + "\n";
			
			detail = "";
			
			handler.post(doUpdateStatus);
		}
		
		private Runnable doUpdateStatus = new Runnable()
		{
			public void run()
			{		
				infoText.setText(info);
				dataText.setText(detail);
			}
		};
		
		private class CommandButtonListener implements OnClickListener {

			private Dialog dlgSendCmd;
			private EditText edtCmd;
			private EditText edtSubCmd;
			private EditText edtCmdData;
			AlertDialog ad = null;

			public void onClick(View v) {
				final ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>(
	                    getActivity(), R.layout.command_dialog, commands);
				AlertDialog.Builder commandBuilder = new AlertDialog.Builder(getActivity());
				commandBuilder.setTitle("Select a Command");
				commandBuilder.setAdapter(arrayAdapter, new DialogInterface.OnClickListener () {

					public void onClick(DialogInterface dialog, int which) {
						if (device == null)
							return;

						StringBuilder sb = new StringBuilder();
						int ret;
						ResDataStruct resData = new ResDataStruct();

						switch (which) {
						case 0:
							ret = device.device_getFirmwareVersion(sb);
							if (ret == ErrorCode.SUCCESS) {
								info = "Firmware Version: " + sb.toString();
							}
							else {
								info = "GetFirmwareVersion: Failed\n";
								info += "Status: "+device.device_getResponseCodeString(ret)+"";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 1:
							ret = device.config_getSerialNumber(sb);
							if (ret == ErrorCode.SUCCESS) {
								info = "Serial Number: " + sb.toString();
							}
							else {
								info = "GetSerialNumber: Failed\n";
								info += "Status: "+device.device_getResponseCodeString(ret)+"";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 2:
							dlgSendCmd = new Dialog(getActivity());
							dlgSendCmd.setTitle("Please Enter Command");
							dlgSendCmd.setCancelable(false);
							
							Button btnSendCmd;
							Button btnCancelCmd;
							
							dlgSendCmd.setContentView(R.layout.nga_send_command_dialog);
							CheckBox checkbox_lrc = (CheckBox)dlgSendCmd.findViewById(R.id.checkbox_lrc);
							checkbox_lrc.setVisibility(android.view.View.GONE);
							Common.setCalculateLRC(true);
							calcLRC = true;
							
							btnSendCmd = (Button) dlgSendCmd.findViewById(R.id.btnNgaSendCmd);
							btnSendCmd.setText("Send Command");
							btnCancelCmd = (Button) dlgSendCmd.findViewById(R.id.btnNgaCancelCmd);
							edtCmd = (EditText) dlgSendCmd.findViewById(R.id.edtNgaCmd);
							btnSendCmd.setOnClickListener(sendCmdOnClick);
							btnCancelCmd.setOnClickListener(cancelCmdOnClick);
							dlgSendCmd.show();
							
							break;	
						case 3:
							device.device_reviewAllSetting(resData);
							info = "Firmware Settings:";
							detail = Common.getHexStringFromBytes(resData.resData);
							handler.post(doUpdateStatus);
							break;
						case 4:
							ret = device.device_enableTDES(resData);
							if (ret == ErrorCode.SUCCESS) {
								info = "Send EnableTDES command succeeded\n";
							}
							else {
								info = "Failed to send EnableTDES command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 5:
							ret = device.device_enableAES(resData);
							if (ret == ErrorCode.SUCCESS) {
								info = "Send EnableAES command succeeded\n";
							}
							else {
								info = "Failed to send EnableAES command\n";
							}
							handler.post(doUpdateStatus);
							break;
						case 6:
							ret = device.device_getKSN(resData);
							if (ret == ErrorCode.SUCCESS) {
								if (resData.resData != null)
									info = "Get Next KSN: Successful <" + Common.base16Encode(resData.resData)+">";
								else
									info = "Get Next KSN: Successful";
							}
							else {
								info = "Get Next KSN: Failed\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 7:
							ret = device.msr_defaultAllSetting();
							if (ret == ErrorCode.SUCCESS) {
								info = "Default Settings succeeded\n";
							}
							else {
								info = "Failed to send Default Settings command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 8:
							ret = device.device_enableErrorNotification(resData, true);
							if (ret == ErrorCode.SUCCESS) {
								info = "Enable Error Notif. succeeded\n";
							}
							else {
								info = "Failed to send Enable Error Notif. command\n";
							}
							handler.post(doUpdateStatus);
							break;
						case 9:
							ret = device.device_enableErrorNotification(resData, false);
							if (ret == ErrorCode.SUCCESS) {
								info = "Disable Error Notif. succeeded\n";
							}
							else {
								info = "Failed to send Disable Error Notif. command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 10:
							ret = device.device_enableExpDate(resData, true);
							if (ret == ErrorCode.SUCCESS) {
								info = "Enable Exp. Date succeeded\n";
							}
							else {
								info = "Failed to send Enable Exp. Date command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 11:
							ret = device.device_enableExpDate(resData, false);
							if (ret == ErrorCode.SUCCESS) {
								info = "Disable Exp. Date succeeded\n";
							}
							else {
								info = "Failed to send Disable Exp. Date command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 12:
							ret = device.device_setEnhancedMode(resData, true);
							if (ret == ErrorCode.SUCCESS) {
								info = "Set Enhanced Encryption mode succeeded\n";
							}
							else {
								info = "Failed to send Set Enhanced Encryption mode command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 13:
						{
							ret = device.device_setEnhancedMode(resData, false);
							if (ret == ErrorCode.SUCCESS) {
								info = "Set Original Encryption mode succeeded\n";
							}
							else {
								info = "Failed to send Set Original Encryption mode command\n";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						}
						case 14:
							if (device.device_getDeviceType() == DEVICE_TYPE.DEVICE_SECUREMAG)
							{
								ret = device.device_switchToKeyboardMode(resData);
								if (ret == ErrorCode.SUCCESS) {
									ad.dismiss();
//									info = "Switch to Keyboard mode succeeded, please reselect the reader from the option menu after it is disconnected\n";
//									detail = "";
//									handler.post(doUpdateStatus);
									switchToKB = true;
//									try {
//			        	                Thread.sleep(3000);
//			        	            } catch (InterruptedException ex) {
//			        	               
//			        	            }
									openReader();
								}
								else {
									info = "Failed to send Switch to Keyboard mode command\n";
									detail = "";
									handler.post(doUpdateStatus);
								}
							}
							else if (device.device_getDeviceType() == DEVICE_TYPE.DEVICE_SECUREMAG_KB)
							{
								ret = device.device_switchToHidMode(resData);
								if (ret == ErrorCode.SUCCESS) {
									ad.dismiss();
//									info = "Switch to Keyboard mode succeeded, please reselect the reader from the option menu after it is disconnected\n";
//									detail = "";
//									handler.post(doUpdateStatus);
									switchToKB = false;
//									try {
//			        	                Thread.sleep(3000);
//			        	            } catch (InterruptedException ex) {
//			        	               
//			        	            }
									openReader();
								}
								else {
									info = "Failed to send Switch to Keyboard mode command\n";
									detail = "";
									handler.post(doUpdateStatus);
								}
							}
							break;
						default:
							info = "Feature not implemented yet";
							detail = "";
							handler.post(doUpdateStatus);
						}
					}
					
				});
				
				commandBuilder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
					
					public void onClick(DialogInterface dialog, int which) {
					}
				});
//				commandBuilder.create().show();	
				
				ad = commandBuilder.show();
			}
			
			private View.OnClickListener sendCmdOnClick = new View.OnClickListener(){
				public void onClick(View v){
					String strCmd = edtCmd.getText().toString();
					String strSubCmd = "";
					String strCmdData = "";
					strSubCmd = edtSubCmd.getText().toString();
					strCmdData = edtCmdData.getText().toString();
					ResDataStruct resData = new ResDataStruct();
					
					int ret;
					if (strCmd.length()<=0 || strCmd.length()%2 == 1 || strSubCmd.length()<=0 || strSubCmd.length()%2 == 1) {
						Toast.makeText(getActivity(), "Command could not be sent", Toast.LENGTH_SHORT).show();
						return;
					}
					
					if (strCmdData != null && strCmdData.length()%2 == 1) {
						Toast.makeText(getActivity(), "Command could not be sent", Toast.LENGTH_SHORT).show();
						return;
					}

					dlgSendCmd.dismiss();
					ret = device.device_sendDataCommand(strCmd+strSubCmd, calcLRC, strCmdData, resData);
					if (ret == ErrorCode.SUCCESS){
						info = "Send Command " + strCmd + ((strSubCmd == "")?"":" ") + strSubCmd + " Succeeded\n";
						detail = "Send Command " + strCmd + ((strSubCmd == "")?"":" ") + strSubCmd + "\nResult: <" + Common.base16Encode(resData.resData) + ">\n\n";
						
						if (resData.resData != null && resData.resData.length > 0)
						{
								detail += "Result data in Hex: <" + Common.base16Encode(resData.resData) + ">\n\n";
								detail += "Result data in ASCII: <" + Common.getAsciiFromByte(resData.resData) + ">";
						}
					} else {
						info = "Send Command " + strCmd + ((strSubCmd == "")?"":" ") + strSubCmd + " Failed\n";
						info += "Status: "+device.device_getResponseCodeString(ret)+"";
						detail = "";
					}
					handler.post(doUpdateStatus);
				}
			};
			
			private View.OnClickListener cancelCmdOnClick = new View.OnClickListener(){
				public void onClick(View v){
					dlgSendCmd.cancel();
				}
				
			};
		}

		////////////// CALLBACKS /////////////
		public void deviceConnected() {

			getActivity().runOnUiThread(new Runnable() {
				public void run() {
					status.setText("Connected");
					String device_name = device.device_getDeviceType().toString();
					info = device_name.replace("DEVICE_", "");
					info += " Reader is connected\r\n";
					detail = "";
					handler.post(doUpdateStatus);
					Toast.makeText(getActivity(), "Reader Connected", Toast.LENGTH_LONG).show();
				}
			});
		}
	
		public void deviceDisconnected() {
			getActivity().runOnUiThread(new Runnable() {
				public void run() {
					status.setText("Disconnected");
					commandBtn.setEnabled(true);
					if (!Common.getBootLoaderMode())
					{
						info = "Reader is disconnected";
						detail = "";
						handler.post(doUpdateStatus);
					}
				}
			});
		}

		public void timeout(int errorCode) {
			info = ErrorCodeInfo.getErrorCodeDescription(errorCode);
			detail = "";
			handler.post(doUpdateStatus);
			commandBtn.setEnabled(true);
		}
		
		public void autoConfigCompleted(StructConfigParameters profile) {
			
		}

		public void autoConfigProgress(int progressValue) {

		}

		public void ICCNotifyInfo(byte[] dataNotify, String strMessage) {
			if(strMessage!=null && strMessage.length()>0)
			{
				String strHexResp = Common.getHexStringFromBytes(dataNotify);
		 		Log.d("Demo Info >>>>>","dataNotify="+ strHexResp);
	
				info = "ICC Notification Info: "+strMessage+"\n"+"Resp: "+strHexResp;
				detail="";
				handler.post(doUpdateStatus);
			}
		}

		public void msgToConnectDevice() {
			info = "Connecting a reader...";
			detail = "";
			handler.post(doUpdateStatus);
		}

		public void msgAudioVolumeAjustFailed() {

		}
		
		public void LoadXMLConfigFailureInfo(int index, String strMessage) {

		}

		public void msgRKICompleted(String MACResult) {
			info = "Remote Key Injection Succeeded\nMac result: 0x"+MACResult;
			detail = "";
			handler.post(doUpdateStatus);
		}
		
		public void dataInOutMonitor(byte[] data, boolean isIncoming) {
			
		}
		
		IDTEMVData _card;
		public void emvTransactionData(IDTEMVData emvData) {

		}
		
		IDTMSRData msr_card;
		//Callback function for MSR swipe
		public void swipeMSRData(IDTMSRData card) {
			msr_card = card;
			
			getActivity().runOnUiThread(new Runnable() {
				 public void run() {

					if (msr_card.result != ErrorCode.SUCCESS)
					{
						info = "MSR card data didn't read correctly\n";
						info += ErrorCodeInfo.getErrorCodeDescription(msr_card.result);
						if (msr_card.result != ErrorCode.FAILED_NACK)
						{
							detail = "";
							commandBtn.setEnabled(true);
							handler.post(doUpdateStatus);
							return;
						}
					}
					else
					{
						info = "MSR Card tapped/Swiped Successfully";
					}
					info = new String(msr_card.cardData);
					detail = Common.getHexStringFromBytes(msr_card.cardData);
					commandBtn.setEnabled(true);
					handler.post(doUpdateStatus);
				}
				 
			 });
		}
		
		public void msgBatteryLow() {
			// TODO Auto-generated method stub
			
		}

		public void getProfileResult(String output) {

		}

		public void postProfileResult(String s) {
			Toast.makeText(getActivity(), "Post: "+ s, Toast.LENGTH_SHORT).show();
			
		}

	}

}
